package com.yonge.cooleshow.biz.dal.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class LessonCourseware {
	@ApiModelProperty(value = "主键")
	@TableId(value = "id_", type = IdType.AUTO)
	private Integer id;

	@ApiModelProperty(value = "关联声部")
	@TableField(value = "subject_id_")
	private Integer subjectId;

	@ApiModelProperty(value = "课件编号")
	@TableField(value = "lesson_course_id_")
	private Long lessonCourseId;

	@ApiModelProperty(value = "是否启用")
	@TableField(value = "enable_")
	private Boolean enable = false;

	@ApiModelProperty(value = "更新时间")
	@TableField(value = "update_time_")
	private Date updateTime;

	@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time_")
	private Date createTime;
}
